Subject: Re: [bug#69899] [PATCH 0/7] support to use `guix system vm' with riscv64.

From: Ludovic Courtès <[email-masked]>
Date: Sun, 31 Mar 2024 23:02:54 +0200

Hi,

Zheng Junjie <[email-masked]> skribis:

> Leo Famulari <[email-masked]> writes:
>
>> Hi, thanks for these patches!
>>
>> On Tue, Mar 19, 2024 at 11:15:53PM +0800, Zheng Junjie wrote:
>>> hello!. this patchset make `guix system vm --target=riscv64-linux-gnu' work.
>>> and `guix system vm --system=riscv64-linux` also work, But there is a problem
>>> that the qemu running with --system=riscv64-linux is also riscv architecture,
>>> now you have to manually modify to use native qemu or the guix of qemu-system
>>> on qemu-user is too slow. and must enable qemu-binfmt.
>>
>> So, what should we do about the problem? What's the ideal solution for
>> Guix? I don't have any experience with this subject matter.
>
> I've come up with two ideas:
>
> 1. Force the current system's qemu to be used, on x86_64 and -s
> riscv64-linux, use x86_64's qemu.
> 2. add an environment variable, GUIX_QEMU, to allow the internal qemu
> execution to be replaced
>
> There may be other solutions, but I can't think of them yet.

Thing is, ‘--system=X’ is supposed to be giving the exact same result as
if you were building natively on X.  Thus, it’s not surprising that
‘guix system vm --system=X’ gives on a QEMU binary built for X.

Now, it’s admittedly not very useful in this case.  I believe the
attached patch implements #1 (I wasn’t able to test it yet because too
many things had to be built).  How does it sound?

diff --git a/gnu/system/vm.scm b/gnu/system/vm.scm
index 7d9d07ebb7..a2743453e7 100644
--- a/gnu/system/vm.scm
+++ b/gnu/system/vm.scm
@@ -287,8 +287,11 @@ (define* (system-qemu-image/shared-store-script os
       #~(format #f "/tmp/guix-image-~a" (basename #$base-image)))
 
     (define qemu-exec
-      #~(list #+(file-append qemu "/bin/"
-                             (qemu-command (or target system)))
+      #~(list #+(with-parameters ((%current-system %system)
+                                  (%current-target-system #f))
+                  ;; Override %CURRENT-SYSTEM to always use a native emulator.
+                  (file-append qemu "/bin/"
+                               (qemu-command (or target system))))
               ;; Tells qemu to use the terminal it was started in for IO.
               #$@(if graphic? '() #~("-nographic"))
               #$@(if full-boot?

Thanks,
Ludo’.